<template>
  <div class="_container--small">
    <section>
      <h1>{{ $t('js.maps.index.title') }}</h1>

      <rui-empty v-if="noMaps" :content="$t('js.map.index.no_map_available')" />

      <rui-list-item v-for="map in ownedMaps"
                     :key="`owned_${map.id}`"
                     :caption="map.name"
                     :to="{name: 'map', params: { mapId: map.id }}">
        <template #left>
          <rui-button :icon="account.preferences.map === map.id ? 'unpin' : 'pin'"
                      text
                      :title="$t('js.map.index.favorite_help')"
                      :variant="account.preferences.map === map.id ? 'recording' : 'dim'"
                      @click="toggleFavorite(map.id)" />
        </template>
        <template #right>
          <rui-button :to="{name: 'editMap', params: {mapId: map.id} }" icon="pencil" :title="$t('generic.edit')" />

          <rui-button icon="world"
                      :href="`/shared/maps/${map.id}`"
                      :title="$t('js.map.index.display_shared_version')"
                      :disabled="!map.publiclyAvailable" />

          <rui-button icon="trash" variant="destructive" :title="$t('generic.destroy')" @click="trashMap(map.id)" />
        </template>
      </rui-list-item>

      <rui-button :to="{name: 'newPictureMap'}" variant="creative" block class="-mtd">{{ $t('js.maps.index.new_map') }}</rui-button>

      <h2 v-if="otherMaps.length > 0">{{ $t('js.maps.other_maps') }}</h2>

      <rui-list-item v-for="map in otherMaps"
                     :key="`other_${map.id}`"
                     :caption="map.name"
                     :to="{name: 'map', params: { mapId: map.id }}" />
    </section>

    <section>
      <h2 class="-h1">{{ $t('js.gardens.home.tools') }}</h2>
      <rui-list-item :caption="$t('js.gardens.home.library')"
                     :sub-caption="$t('js.gardens.home.library_description')"
                     icon="library"
                     :to="{ name: 'library' }" />
      <rui-list-item :caption="$t('js.gardens.home.soil_analysis')"
                     :sub-caption="$t('js.gardens.home.soil_analysis_description')"
                     icon="soil-analysis"
                     :to="{ name: 'soilAnalysis' }" />
    </section>
  </div>
</template>

<script>
import RuiButton from '@experiments-labs/rise_ui/src/components/Button/Button.vue'
import RuiEmpty from '@experiments-labs/rise_ui/src/components/DataDisplay/Empty/Empty.vue'
import RuiListItem from '@experiments-labs/rise_ui/src/components/ListItem/ListItem.vue'

import Toaster from '../../../tools/Toaster'

export default {
  name: 'GpaHome',
  components: { RuiButton, RuiListItem, RuiEmpty },
  computed: {
    ownedMaps () { return this.$store.getters.ownedMaps },
    otherMaps () { return this.$store.getters.otherMaps },
    account () { return this.$store.getters.account },
    noMaps () { return this.ownedMaps.length + this.otherMaps.length === 0 },
  },
  methods: {
    trashMap (mapId) {
      this.$emitBus('ask-confirmation', {
        caption: this.$t('js.map.destroy_confirm_title'),
        message: this.$t('js.map.destroy_confirm'),
        callback: () => {
          this.$store.dispatch('destroyMap', mapId)
            .then(() => { Toaster.success(this.$t('js.map.successfully_destroyed')) })
            .catch(() => { Toaster.error(this.$t('js.map.failed_to_destroy')) })
        },
      })
    },
    toggleFavorite (mapId) {
      let newFavorite = mapId
      if (this.account.preferences.map === mapId) newFavorite = null
      const preferences = { ...this.account.preferences, map: newFavorite }
      this.$store.dispatch('updateAccount', { preferences })
    },
  },
}
</script>
